<style>
.custom-select {
    padding: 0;
    max-width: 250px;
}

.custom-select > div:first-child {
    vertical-align: middle;
    align-self: center;
    margin-top: 19px;
    border: none;
}

.custom-select .vs__actions {
    line-height: 15px;
}

.custom-select .vs__actions button {
    display: none;
    background-color: #fff !important;
    padding: 5px;
}

.custom-select .vs__dropdown-menu {
    color: #6b707f;
    padding: 0;
    margin-top: 4px;
}

.custom-select .vs__dropdown-option {
    color: #6b707f;
}

.custom-select .vs__dropdown-option.vs__dropdown-option--highlight {
    background: #f4f9fa;
}

.custom-select .vs__dropdown-option.vs__dropdown-option--highlight,
.custom-select .vs__dropdown-option.vs__dropdown-option--selected {
    color: #254061;
    outline-color: #254061;
    font-weight: bold;
    /* position: relative; */
}

.custom-select .vs__dropdown-option.vs__dropdown-option--highlight:before,
.custom-select .vs__dropdown-option.vs__dropdown-option--selected:before {
    height: 100%;
    position: absolute;
    top: 0;
    left: 0;
}

/*vs__dropdown-option vs__dropdown-option--selected vs__dropdown-option--highlight*/

</style>
<template>
    <section class="breadcrumb_area search">
        <div class="container custom_container">
            <div v-if="modeView === 'recent'" class="doc_banner_text text-center">
                <br />
                <h2 class="wow fadeInUp" data-wow-delay="0.3s">VZAT - Venezuela Analysis Team</h2>
                <p class="wow fadeInUp" data-wow-delay="0.5s">{{ $t("titles.submain_search") }}</p>
                <br />
            </div>
            <form class="banner_search_form banner_search_form_two">
                <div class="input-group">
                    <input type="search" v-model="displayedTextSearch" class="form-control" :placeholder="$t('actions.search_reports')">
                    <VueSelect :options="stateOptions" class="custom-select" v-model="selectedState" :reduce="option => option.code" />
                    <!-- <div class="input-group-append">
                        <select class="custom-select" id="inlineFormCustomSelect" v-model="selectedState">
                            <option value="" selected>{{ $t("options.all_documents") }}</option>
                            <option v-for="state in states" v-bind:key="state.id" :value="state.id">{{ state.name }}</option>
                        </select>
                    </div> -->
                    <button type="submit" v-on:click.prevent="search()"><i class="icon_search"></i></button>
                </div>
            </form>
            <div v-if="modeView === 'recent'" class="text-center">
                <br />
                <p><a v-on:click.prevent="fetchAll()" href="#" class="yellow-lnk bold">{{ $t("actions.see_all_documents") }} <i class="fas fa-arrow-right"></i></a></p>
            </div>
        </div>
    </section>
</template>
<script type="module">
import VueSelect from 'vue-select';
import 'vue-select/dist/vue-select.css';
export default{
	name: 'SearchForm',
	props: ['textSearch', 'categories', 'states', 'modeView'],
	components: {
        VueSelect,
	},
	data() {
		return {
            displayedTextSearch: '',
			selectedCategory: '',
			selectedState: '',
		};
	},
	mounted() {
		
	},
	methods: {
		search() {
            this.$emit('search', this.displayedTextSearch, this.selectedCategory ?? '', this.selectedState ?? '')
        },
        fetchAll() {
            this.$emit('fetchAll');
        }
	},
	computed: {
		stateOptions() {
            const options = this.states.map(option => {
                return {
                    label: option.name,
                    code: option.id,
                }
            });

            return [
                { label: this.$t("options.all_states"), code: '' },
                ...options
            ];
        }
	},
	watch: {
		textSearch() {
            this.displayedTextSearch = this.textSearch;
        },
        // categories() {
        //     $('.custom-select').niceSelect('destroy');
        //     $('.custom-select').niceSelect();
        // },
        // states() {
        //     setTimeout(() => {
        //         $('.custom-select').niceSelect('destroy');
        //         $('.custom-select').niceSelect();
        //     }, 1000);
        // }
	}
};
</script>